/* This program creates the system matrices
** for the DGP
*/
#include c:\projects\active\mismodel\gauss\mcspec.g
cls;

/* Configuration of Moving Average Representation
*/
Fla1 = 0.9;    /* Eigenvalues */
Fla2 = 0.5;
Fth1 = pi/4;   /* Eigenvectors */
Fth2 = 5*pi/6;

VA1 = 1;      /* Prior variance for A1 */
Vdecay = -2;   /* Hyperbolic decay rate */

/* Create System matrices */

Vtheta = ( cos(Fth1) ~ cos(Fth2) )|
         ( sin(Fth1) ~ sin(Fth2) );
         
LAM = ( Fla1 ~ 0 )|
      ( 0 ~ Fla2 );
      
Fdgp = Vtheta*LAM*inv(Vtheta);
Adgp = zeros(y_n,y_n*A_n);

i = 1;
do until i > A_n;
   Adgp[.,1+(i-1)*y_n:i*y_n] = sqrt( VA1*i^Vdecay )*rndn(y_n,y_n);  
   i = i+1;
endo;

/* Covariance Matrix
*/
sig1 = 0.01;
sig2 = 0.02;
r12  = 0.4;

SIGeps = ( sig1^2 ~ r12*sig1*sig2 ) |
         ( r12*sig1*sig2 ~ sig2^2 ) ;

SIGeps = SIGeps;
         
/* Weight Matrix
*/
Wla1 = 0.6;    /* Eigenvalues */
Wla2 = 0.5;
Wth1 = pi/4;   /* Eigenvectors */

Vtheta = ( cos(Wth1) ~ -sin(Wth1) )|
         ( sin(Wth1) ~  cos(Wth1) );
         
LAM = ( Wla1 ~ 0 )|
      ( 0 ~ Wla2 );
      
Wloss = Vtheta*LAM*Vtheta';

/* Print Configuration to Screen
*/

"Weight of Loss Function";
"-----------------------";
Wloss;
"";
"";

"Autoregressive Matrix";
"---------------------";
Fdgp;
"";
"";

"Covariance Matrix";
"-----------------";
SIGeps;
"";
"";

"MA coefficients of distortion process";
"-------------------------------------";
i = 1;
do until i > A_n;
   "";
   "Lag" i;
   Adgp[.,1+(i-1)*y_n:i*y_n];
   "";
   i = i+1;
endo;

save path = ^mcoutpath Fdgp, Adgp, SIGeps, Wloss;
 
