/* This program generates data from the DGP 
** and computes Forecast error losses for 
** various prediction procedures
*/
new;
cls;
#include c:\projects\active\mismodel\gauss\mcspec.g


load path = ^mcoutpath Fdgp, Adgp, SIGeps, Wloss;

/* Initializations */

/* Individual */

loss_mle = zeros(T_n*h_n,alp_n*p_n);
loss_lfe = zeros(T_n*h_n,alp_n*p_n);
loss_opt = zeros(T_n*h_n,alp_n*3);     /* Format: mle(optimal PC lag), lfe(optimal PC lag), optimal PC lag/predictor */
loss_optbylag = zeros(T_n*h_n,alp_n*p_n);
loss_aic = zeros(T_n*h_n,alp_n*3);     /* Format: mle(optimal AIC lag), lfe(optimal AIC lag), optimal lag AIC / PC predictor */
loss_bic = zeros(T_n*h_n,alp_n*3);     /* Format: mle(optimal BIC lag), lfe(optimal BIC lag), optimal lag BIC / PC predictor */

PC_mle = zeros(T_n*h_n,alp_n*p_n);
PC_lfe = zeros(T_n*h_n,alp_n*p_n);
AIC_mle = zeros(T_n*h_n,alp_n*p_n);
BIC_mle = zeros(T_n*h_n,alp_n*p_n);
relPC_mle = zeros(T_n*h_n,alp_n*p_n);
relPC_lfe = zeros(T_n*h_n,alp_n*p_n);

Pindhat_mle = zeros(T_n*h_n,alp_n);
Pindhat_lfe = zeros(T_n*h_n,alp_n);
AICindhat   = zeros(T_n*h_n,alp_n);
BICindhat   = zeros(T_n*h_n,alp_n);

Predsel      = zeros(T_n*h_n,alp_n);
Predselbylag = zeros(T_n*h_n,alp_n*p_n);
Jointsel     = zeros(T_n*h_n,alp_n*2*p_n);
AICsel       = zeros(T_n*h_n,alp_n*2*p_n);
BICsel       = zeros(T_n*h_n,alp_n*2*p_n);

/* Cumulative */

/* Forecast losses */

loss_mlesum  = zeros(T_n*h_n,alp_n*p_n);
loss_mlesum2 = zeros(T_n*h_n,alp_n*p_n);

loss_lfesum  = zeros(T_n*h_n,alp_n*p_n);
loss_lfesum2 = zeros(T_n*h_n,alp_n*p_n);

loss_optsum  = zeros(T_n*h_n,alp_n*3);
loss_optsum2 = zeros(T_n*h_n,alp_n*3);

loss_aicsum  = zeros(T_n*h_n,alp_n*3);
loss_aicsum2 = zeros(T_n*h_n,alp_n*3);

loss_bicsum  = zeros(T_n*h_n,alp_n*3);
loss_bicsum2 = zeros(T_n*h_n,alp_n*3);

loss_optbylagsum  = zeros(T_n*h_n,alp_n*p_n);
loss_optbylagsum2 = zeros(T_n*h_n,alp_n*p_n);

/* Value of PC */

PC_mlesum    = zeros(T_n*h_n,alp_n*p_n);
PC_mlesum2   = zeros(T_n*h_n,alp_n*p_n);

PC_lfesum    = zeros(T_n*h_n,alp_n*p_n);
PC_lfesum2   = zeros(T_n*h_n,alp_n*p_n);

/* Value of PC differentials */

relPC_mlesum    = zeros(T_n*h_n,alp_n*p_n);
relPC_mlesum2   = zeros(T_n*h_n,alp_n*p_n);

relPC_lfesum    = zeros(T_n*h_n,alp_n*p_n);
relPC_lfesum2   = zeros(T_n*h_n,alp_n*p_n);

/* Selection Counts */

Jointsel_count  = zeros(T_n*h_n,alp_n*2*p_n);
AICsel_count    = zeros(T_n*h_n,alp_n*2*p_n);
BICsel_count    = zeros(T_n*h_n,alp_n*2*p_n);

sim_ind = 1;
do until sim_ind > sim_n;

   gosub simstep;

   /* Forecast losses */

   loss_mlesum  = loss_mlesum  + loss_mle;
   loss_mlesum2 = loss_mlesum2 + loss_mle^2;

   loss_lfesum  = loss_lfesum  + loss_lfe;
   loss_lfesum2 = loss_lfesum2 + loss_lfe^2;

   loss_optsum  = loss_optsum  + loss_opt;
   loss_optsum2 = loss_optsum2 + loss_opt^2;

   loss_aicsum  = loss_aicsum  + loss_aic;
   loss_aicsum2 = loss_aicsum2 + loss_aic^2;

   loss_bicsum  = loss_bicsum  + loss_bic;
   loss_bicsum2 = loss_bicsum2 + loss_bic^2;

   loss_optbylagsum  = loss_optbylagsum  + loss_optbylag;
   loss_optbylagsum2 = loss_optbylagsum2 + loss_optbylag^2;

   /* Value of PC */

   pc_mlesum  = pc_mlesum  + pc_mle;
   pc_mlesum2 = pc_mlesum2 + pc_mle^2;

   pc_lfesum  = pc_lfesum  + pc_lfe;
   pc_lfesum2 = pc_lfesum2 + pc_lfe^2;

   /* Value of PC differentials */

   relpc_mlesum  = relpc_mlesum  + relpc_mle;
   relpc_mlesum2 = relpc_mlesum2 + relpc_mle^2;

   relpc_lfesum  = relpc_lfesum  + relpc_lfe;
   relpc_lfesum2 = relpc_lfesum2 + relpc_lfe^2;

   /* Selection Counts */

   Jointsel_count = Jointsel_count + Jointsel;
   AICsel_count   = AICsel_count + AICsel;
   BICsel_count   = BICsel_count + BICsel;
   
   locate 1,1;
   "Simulation Step " sim_ind;
   "of              " sim_n;

   sim_ind = sim_ind+1;

endo;

risk_mlemc = loss_mlesum / sim_n;
risk_mlese = sqrt( loss_mlesum2 / sim_n - (risk_mlemc)^2 );

risk_lfemc = loss_lfesum / sim_n;
risk_lfese = sqrt( loss_lfesum2 / sim_n - (risk_lfemc)^2 );

risk_optmc = loss_optsum / sim_n;
risk_optse = sqrt( loss_optsum2 / sim_n - (risk_optmc)^2 );

risk_aicmc = loss_aicsum / sim_n;
risk_aicse = sqrt( loss_aicsum2 / sim_n - (risk_aicmc)^2 );

risk_bicmc = loss_bicsum / sim_n;
risk_bicse = sqrt( loss_bicsum2 / sim_n - (risk_bicmc)^2 );

risk_optbylagmc = loss_optbylagsum / sim_n;
risk_optbylagse = sqrt( loss_optbylagsum2 / sim_n - (risk_optbylagmc)^2 );

pc_mlemc = pc_mlesum / sim_n;
pc_mlese = sqrt( pc_mlesum2 / sim_n - (pc_mlemc)^2 );

pc_lfemc = pc_lfesum / sim_n;
pc_lfese = sqrt( pc_lfesum2 / sim_n - (pc_lfemc)^2 );

relpc_mlemc = relpc_mlesum / sim_n;
relpc_mlese = sqrt( relpc_mlesum2 / sim_n - (relpc_mlemc)^2 );

relpc_lfemc = relpc_lfesum / sim_n;
relpc_lfese = sqrt( relpc_lfesum2 / sim_n - (relpc_lfemc)^2 );

Jointsel_count = Jointsel_count/sim_n;
AICsel_count   = AICsel_count/sim_n;
BICsel_count   = BICsel_count/sim_n;

save path = ^mcoutpath risk_mlemc, risk_mlese, risk_lfemc, risk_lfese,
                       risk_optmc, risk_optse, risk_aicmc, risk_aicse, risk_bicmc, risk_bicse, 
                       risk_optbylagmc, risk_optbylagse,
                       pc_mlemc, pc_mlese, pc_lfemc, pc_lfese,
                       relpc_mlemc, relpc_mlese, relpc_lfemc, relpc_lfese,
                       Jointsel_count, AICsel_count, BICsel_count;

clear risk_mlemc, risk_mlese, risk_lfemc, risk_lfese,
      risk_optmc, risk_optse, risk_aicmc, risk_aicse, risk_bicmc, risk_bicse, 
      risk_optbylagmc, risk_optbylagse,
      pc_mlemc, pc_mlese, pc_lfemc, pc_lfese,
      relpc_mlemc, relpc_mlese, relpc_lfemc, relpc_lfese,
      Jointsel_count, AICsel_count, BICsel_count;

end;

/****************************************************************
**                  S U B R O U T I N E 
*/
simstep:

Jointsel = zeros(T_n*h_n,alp_n*2*p_n);
AICsel   = zeros(T_n*h_n,alp_n*2*p_n);
BICsel   = zeros(T_n*h_n,alp_n*2*p_n);

/* Generate Estimation sample
*/
yt = genryt(0);

/* Generate Forecast sample
*/
{ytildeT, ytildeTh} = genrytilde(0);

/****************************************************************
** Compute Matrix of Predictions
*/
yypred_mle = zeros(p_n*h_n,y_n*alp_n*T_n);
yypred_lfe = zeros(p_n*h_n,y_n*alp_n*T_n);

T_ind = 1;
do until T_ind > T_n;

   alp_ind = 1;
   do until alp_ind > alp_n;

      h_ind = 1;
      do until h_ind > h_n;    

         /* Build the matrix of dependent variables / regressors 
         */
         colind = y_n*( (T_ind-1)*alp_n+(alp_ind-1) );
         yy  = yt[p_max+h_max:p_max+h_max+T[T_ind]-1,colind+1:colind+y_n];
         yy1 = yt[p_max+h_max-1:p_max+h_max-1+T[T_ind]-1,colind+1:colind+y_n];
         yyh = yt[p_max+h_max-h[h_ind]:p_max+h_max-h[h_ind]+T[T_ind]-1,colind+1:colind+y_n];

         Mp = eye(y_n);

         p_ind = 1;
         do until p_ind > p_n;

            /* Create data matrices */
            if p[p_ind] > 1;
               yy  = yy  ~ yt[p_max+h_max-(p_ind-1):p_max+h_max+T[T_ind]-1-(p_ind-1),colind+1:colind+y_n];
               yy1 = yy1 ~ yt[p_max+h_max-1-(p_ind-1):p_max+h_max-1+T[T_ind]-1-(p_ind-1),colind+1:colind+y_n];
               yyh = yyh ~ yt[p_max+h_max-h[h_ind]-(p_ind-1):p_max+h_max-h[h_ind]+T[T_ind]-1-(p_ind-1),colind+1:colind+y_n];
               Mp = Mp | zeros(y_n,y_n);
            endif;

            /* Compute MLE and LFE Predictor */           
            psihat_mle = PowerOf( inv(yy1'*yy1)*yy1'*yy , h[h_ind] );
            psihat_lfe = inv(yyh'*yyh)*yyh'*yy;
            fhat       = ( inv(yy1'*yy1)*yy1'*yy )';
            sigeehat   = (yy'yy - yy'*yy1*inv(yy1'*yy1)*yy1'*yy)/rows(yy);
            sigepshat  = Mp'*sigeehat*Mp;
            GamYY0     = yy'yy/rows(yy);
            GamYY0inv  = inv(GamYY0);

            /* Compute Prediction */
            YYT      = vec( rev( ytildeT[p_max-p[p_ind]+1:p_max,colind+1:colind+y_n] )' )';
            YYTh_mle = YYT*psihat_mle*Mp;
            YYTh_lfe = YYT*psihat_lfe*Mp;

            YYpred_mle[(p_ind-1)*h_n+h_ind,colind+1:colind+y_n]=YYTh_mle;
            YYpred_lfe[(p_ind-1)*h_n+h_ind,colind+1:colind+y_n]=YYTh_lfe;
            
            /* Compute Prediction Error Criterion */
                        
            mse_mle = Mp'*(yy - yyh*psihat_mle)'*(yy - yyh*psihat_mle)*Mp/rows(YY);
            mse_lfe = Mp'*(yy - yyh*psihat_lfe)'*(yy - yyh*psihat_lfe)*Mp/rows(YY);

            PCfit_mle = sumc(diag( Wloss*mse_mle ));
            PCfit_lfe = sumc(diag( Wloss*mse_lfe ));
                        
            V_mle = 0;
            V_lfe = 0;
            
            ii = 0;
            do until ii == h[h_ind];
            
               jj = 0;
               do until jj == h[h_ind];
               
                  MFSFM = Mp'*PowerOf(Fhat,h[h_ind]-1-ii)*SigEEhat*PowerOf(Fhat,h[h_ind]-1-jj)'*Mp;
                  if ii GE jj;
                     GamYYij = PowerOf(Fhat,ii-jj)*GamYY0;
                  else;
                     GamYYij = (PowerOf(Fhat,jj-ii)*GamYY0)';
                  endif;
                  V_mle = V_mle + MFSFM .*. ( PowerOf(Fhat,ii)'*GamYY0inv*PowerOf(Fhat,jj) );
                  V_lfe = V_lfe + MFSFM .*. ( GamYY0inv*GamYYij*GamYY0inv );
                  
                  jj = jj+1;
                  
               endo;
               ii = ii+1;
               
            endo;

            V_mle = V_mle/T[T_ind];
            V_lfe = V_lfe/T[T_ind];

           
            PCpenal_mle = 2*sumc(diag( (Wloss.*.GamYY0)*V_mle ));
            PCpenal_lfe = 2*sumc(diag( (Wloss.*.GamYY0)*V_lfe ));
                       
            PC_mle[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+p_ind ]= T[T_ind]*(PCfit_mle + PCpenal_mle);
            PC_lfe[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+p_ind ]= T[T_ind]*(PCfit_lfe + PCpenal_lfe);
            
            /* Compute AIC and BIC */

            AIC_mle[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+p_ind ]
                = -0.5*rows(yy) * ln(det(sigepshat)) - p[p_ind]*y_n^2;
            BIC_mle[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+p_ind ]
                = -0.5*rows(yy) * ln(det(sigepshat)) - 0.5*p[p_ind]*y_n^2*ln(rows(YY));
                        
            p_ind = p_ind+1;
         endo;

         /* relative to LFE with max lag-length */
         relPC_mle[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+1:alp_ind*p_n ]
                     = PC_mle[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+1:alp_ind*p_n ]
                     - PC_lfe[(h_ind-1)*T_n+T_ind, alp_ind*p_n ];  

         /* relative to LFE with same lag-length */
         /*
         relPC_mle[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+1:alp_ind*p_n ]
                     = PC_mle[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+1:alp_ind*p_n ]
                     - PC_lfe[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+1:alp_ind*p_n ]; 
         */

         relPC_lfe[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+1:alp_ind*p_n ]
                     = PC_lfe[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+1:alp_ind*p_n ]
                     - PC_lfe[(h_ind-1)*T_n+T_ind, alp_ind*p_n ];

         /* PC - Estimated number of lags */
         
         pmle = minindc(relPC_mle[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+1:alp_ind*p_n ]');
         plfe = minindc(relPC_lfe[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+1:alp_ind*p_n ]');

         Pindhat_mle[(h_ind-1)*T_n+T_ind, alp_ind] = pmle;
         Pindhat_lfe[(h_ind-1)*T_n+T_ind, alp_ind] = plfe;

         /* 
         ** sel = 1: use mle
         ** sel = 0: use lfe
         */

         /* Lag - by - lag PC selection of LFE vs. MLE */
         
         selbylag = relPC_mle[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+1:alp_ind*p_n ]
                    .< relPC_lfe[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+1:alp_ind*p_n ];
         Predselbylag[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+1:alp_ind*p_n] = selbylag;

         /* Joint PC selection of Lag and MLE vs. LFE 
         ** Selection count: mle - lfe
         */

         sel  = minc(relPC_mle[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+1:alp_ind*p_n ]')
                  < minc(relPC_lfe[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+1:alp_ind*p_n ]') ;
         Predsel[(h_ind-1)*T_n+T_ind, alp_ind] = sel;

         Jointsel[(h_ind-1)*T_n+T_ind,(alp_ind-1)*2*p_n+sel*pmle+(1-sel)*(p_n+plfe)]
           = Jointsel[(h_ind-1)*T_n+T_ind,(alp_ind-1)*2*p_n+sel*pmle+(1-sel)*(p_n+plfe)] + 1;
           

         /* AIC/BIC estimated number of lags */

         paic = maxindc(AIC_mle[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+1:alp_ind*p_n ]');
         pbic = maxindc(BIC_mle[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+1:alp_ind*p_n ]');

         AICindhat[(h_ind-1)*T_n+T_ind, alp_ind] = paic;
         BICindhat[(h_ind-1)*T_n+T_ind, alp_ind] = pbic;
      
         /* Use PC to choose MLE vs. LFE */

         paicsel = selbylag[paic];
         pbicsel = selbylag[pbic];

         /* Update AIC/BIC selection count */
 
         AICsel[(h_ind-1)*T_n+T_ind,(alp_ind-1)*2*p_n+paicsel*paic+(1-paicsel)*(p_n+paic)]
           = AICsel[(h_ind-1)*T_n+T_ind,(alp_ind-1)*2*p_n+paicsel*paic+(1-paicsel)*(p_n+paic)] + 1;
          
         BICsel[(h_ind-1)*T_n+T_ind,(alp_ind-1)*2*p_n+pbicsel*pbic+(1-pbicsel)*(p_n+pbic)]
           = BICsel[(h_ind-1)*T_n+T_ind,(alp_ind-1)*2*p_n+pbicsel*pbic+(1-pbicsel)*(p_n+pbic)] + 1;
         
         h_ind = h_ind + 1;
      endo; 

      alp_ind = alp_ind+1;
   endo;

   T_ind = T_ind + 1;
endo;

"";

/****************************************************************
** Compute Matrix of Forecast Error Losses
*/
loss_mle = zeros(T_n*h_n,alp_n*p_n);
loss_lfe = zeros(T_n*h_n,alp_n*p_n);
loss_opt = zeros(T_n*h_n,alp_n*3);
loss_aic = zeros(T_n*h_n,alp_n*3);
loss_bic = zeros(T_n*h_n,alp_n*3);

T_ind = 1;
do until T_ind > T_n;

   alp_ind = 1;
   do until alp_ind > alp_n;

      h_ind = 1;
      do until h_ind > h_n;    

         colind = y_n*( (T_ind-1)*alp_n+(alp_ind-1) );
         p_ind = 1;
         do until p_ind > p_n;

            ferror_mle = YtildeTh[h[h_ind],colind+1:colind+y_n]
                         -YYpred_mle[(p_ind-1)*h_n+h_ind,colind+1:colind+y_n];
            ferror_lfe = YtildeTh[h[h_ind],colind+1:colind+y_n]
                         -YYpred_lfe[(p_ind-1)*h_n+h_ind,colind+1:colind+y_n];

            loss_mle[(h_ind-1)*T_n+T_ind,(alp_ind-1)*p_n+p_ind] 
                       = T[T_ind]*sumc(diag( Wloss*ferror_mle'*ferror_mle ));
            loss_lfe[(h_ind-1)*T_n+T_ind,(alp_ind-1)*p_n+p_ind] 
                       = T[T_ind]*sumc(diag( Wloss*ferror_lfe'*ferror_lfe ));

            p_ind = p_ind+1;
         endo;

         /* Loss of Selected Predictors */

         pmle = Pindhat_mle[(h_ind-1)*T_n+T_ind, alp_ind];
         plfe = Pindhat_lfe[(h_ind-1)*T_n+T_ind, alp_ind]; 
         paic = AICindhat[(h_ind-1)*T_n+T_ind, alp_ind]; 
         pbic = BICindhat[(h_ind-1)*T_n+T_ind, alp_ind]; 

         sel       = Predsel[(h_ind-1)*T_n+T_ind, alp_ind];
         selbylag  = Predselbylag[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+1:alp_ind*p_n];

         /* 
         ** sel = 1: use mle
         ** sel = 0: use lfe
         */

         loss_opt[(h_ind-1)*T_n+T_ind,(alp_ind-1)*3+1:alp_ind*3] 
           = loss_mle[(h_ind-1)*T_n+T_ind,(alp_ind-1)*p_n+pmle] ~
             loss_lfe[(h_ind-1)*T_n+T_ind,(alp_ind-1)*p_n+plfe] ~ 
             ( sel*loss_mle[(h_ind-1)*T_n+T_ind,(alp_ind-1)*p_n+pmle]
               + (1-sel)*loss_lfe[(h_ind-1)*T_n+T_ind,(alp_ind-1)*p_n+plfe] );

         loss_optbylag[(h_ind-1)*T_n+T_ind,(alp_ind-1)*p_n+1:alp_ind*p_n]
           = ( selbylag.*loss_mle[(h_ind-1)*T_n+T_ind,(alp_ind-1)*p_n+1:alp_ind*p_n]
               + (1-selbylag).*loss_lfe[(h_ind-1)*T_n+T_ind,(alp_ind-1)*p_n+1:alp_ind*p_n] );

         paicsel = selbylag[paic];
         pbicsel = selbylag[pbic];

         loss_aic[(h_ind-1)*T_n+T_ind,(alp_ind-1)*3+1:alp_ind*3] 
           = loss_mle[(h_ind-1)*T_n+T_ind,(alp_ind-1)*p_n+paic] ~
             loss_lfe[(h_ind-1)*T_n+T_ind,(alp_ind-1)*p_n+paic] ~ 
             ( paicsel*loss_mle[(h_ind-1)*T_n+T_ind,(alp_ind-1)*p_n+paic]
               + (1-paicsel)*loss_lfe[(h_ind-1)*T_n+T_ind,(alp_ind-1)*p_n+paic] );

         loss_bic[(h_ind-1)*T_n+T_ind,(alp_ind-1)*3+1:alp_ind*3] 
           = loss_mle[(h_ind-1)*T_n+T_ind,(alp_ind-1)*p_n+pbic] ~
             loss_lfe[(h_ind-1)*T_n+T_ind,(alp_ind-1)*p_n+pbic] ~ 
             ( pbicsel*loss_mle[(h_ind-1)*T_n+T_ind,(alp_ind-1)*p_n+pbic]
               + (1-pbicsel)*loss_lfe[(h_ind-1)*T_n+T_ind,(alp_ind-1)*p_n+pbic] );

         h_ind = h_ind + 1;
      endo; 

      alp_ind = alp_ind+1;
   endo;

   T_ind = T_ind + 1;
endo;

return;

/*******************************************************************
**                         P R O C E D U R E S
*/

proc (1) = genryt(x);
local eps, yt, t_ind, xt;

/* Generate residuals
*/
eps = zeros(A_n,y_n) |
      rndn(T_burn+T_max,y_n)*chol(SIGeps);
           
/* Initialize ytilde
*/
yt = zeros(A_n+T_burn+T_max,y_n*T_n*alp_n);

/* Compute matrix of dependent variables recursively
*/
t_ind = A_n+1;
do until t_ind > (A_n+T_burn+T_max);          

   xt          = (sqrt(1/T').*.alp').*.( Adgp*vec( rev( eps[t_ind-A_n:t_ind-1,.] )' ) )';
   yt[t_ind,.] = yt[t_ind-1,.] * (eye(T_n*alp_n).*.Fdgp')
                 + ones(1,T_n*alp_n).*.eps[t_ind,.]
                 + xt;
   t_ind = t_ind + 1;
   
endo;

yt = yt[A_n+T_burn+1-p_max-(h_max-1):A_n+T_burn+T_max,.];

retp(yt);
endp;

/************************************************************************
*/

proc (2) = genrytilde(x);
local epstilde, ytilde, t_ind, xttilde,
      ytildeT, ytildeTh;
      
/* Generate residuals
*/
epstilde = zeros(A_n,y_n) |
           rndn(T_burn,y_n)*chol(SIGeps) |
           zeros(h_max,y_n);
           
/* Initialize ytilde
*/
ytilde = zeros(A_n + T_burn + h_max, y_n*T_n*alp_n);

/* Compute matrix of dependent variables recursively
*/
t_ind = A_n+1;
do until t_ind > (A_n+T_burn+h_max);          

   xttilde         = (sqrt(1/T').*.alp').*.( Adgp*vec( rev( epstilde[t_ind-A_n:t_ind-1,.] )' ) )';
   ytilde[t_ind,.] = ytilde[t_ind-1,.] * (eye(T_n*alp_n).*.Fdgp')
                   + ones(1,T_n*alp_n).*.epstilde[t_ind,.]
                   + xttilde;
   t_ind = t_ind + 1;
   
endo;

if p_max == 1;
   ytildeT  = ytilde[A_n+T_burn,.];
else;
   ytildeT  = ytilde[A_n+T_burn+1-p_max:A_n+T_burn,.];
endif;

ytildeTh = ytilde[A_n+T_burn+1:A_n+T_burn+h_max,.];

retp(ytildeT,ytildeTh);
endp;

/*************************************************************************
*/

proc (1) = PowerOf(A,h);
local i,Ah;

Ah = eye(rows(A));

if h > 0;
   i = 1;
   do until i > h;
      Ah = Ah*A;
      i = i+1;
   endo;
endif;

retp(Ah);
endp;
