/* This program generates LaTeX tables for the paper
*/
new;
cls;
#include c:\projects\active\mismodel\gauss\mcspec.g


load path = ^mcoutpath Fdgp, Adgp, SIGeps, Wloss;
load path = ^mcoutpath risk_mlemc, risk_mlese, risk_lfemc, risk_lfese,
                       risk_optmc, risk_optse, risk_optbylagmc, risk_optbylagse,
                       pc_mlemc, pc_mlese, pc_lfemc, pc_lfese,
                       relpc_mlemc, relpc_mlese, relpc_lfemc, relpc_lfese,
                       risk_mle, risk_lfe,
                       Jointsel_count;

"Relative Risk and PC Estimates";
"";

/* fix forecast horizon */
h_ind = 3;

/* Iteration over Misspecification */

alp_ind = 1;
do until alp_ind > alp_n;


   tablerow = "\\multicolumn{8}{c}{ Misspecification $\\alpha=$ " 
              $+ ftos(alp[alp_ind],"%*.*lf",2,0) $+ "} \\\\ \\hline";

   $tablerow;

   /* Iteration over sample size */

   T_ind = 1;
   do until T_ind > T_n;
   
      /*
      if T_ind == 1;
         tablerow1 = ftos(alp[alp_ind],"%*.*lf",2,0);
      else;
         tablerow1 = " ";
      endif;
      */      

      tablerow1 = ftos(T[T_ind],"%*.*lf",5,0) $+ " &  Risk" ;   

      tablerow2 = "   & $\\EE[PC]$ ";

      tablerow3 = "   & $ \\sigma[PC]$ ";
         
      p_ind = 1;
      do until p_ind > p_n;
 
         relrisk_mleprt = ( risk_mlemc[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+p_ind ]
                               - risk_lfemc[(h_ind-1)*T_n+T_ind,  alp_ind*p_n ] ) ./
                          risk_lfemc[(h_ind-1)*T_n+T_ind,  alp_ind*p_n ]; 

         relrisk_lfeprt = ( risk_lfemc[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+p_ind ]
                          - risk_lfemc[(h_ind-1)*T_n+T_ind,  alp_ind*p_n ] ) ./
                          risk_lfemc[(h_ind-1)*T_n+T_ind,  alp_ind*p_n ]; 

         relpc_mleprt   = relpc_mlemc[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+p_ind ] ./
                          risk_lfemc[(h_ind-1)*T_n+T_ind,  alp_ind*p_n ];
         
         relpc_mleseprt = relpc_mlese[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+p_ind ] ./
                          risk_lfemc[(h_ind-1)*T_n+T_ind,  alp_ind*p_n ];

         relpc_lfeprt   = relpc_lfemc[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+p_ind ] ./
                          risk_lfemc[(h_ind-1)*T_n+T_ind,  alp_ind*p_n ];
         
         relpc_lfeseprt = relpc_lfese[(h_ind-1)*T_n+T_ind, (alp_ind-1)*p_n+p_ind ] ./
                          risk_lfemc[(h_ind-1)*T_n+T_ind,  alp_ind*p_n ];
       
         tablerow1 = tablerow1 $+ " & " 
                    $+ ftos(100*relrisk_mleprt,"%*.*lf",6,1) $+ " & "
                    $+ ftos(100*relrisk_lfeprt,"%*.*lf",6,1);

         tablerow2 = tablerow2 $+ " & " 
                    $+ ftos(100*relpc_mleprt,"%*.*lf",6,1) $+ " & "
                    $+ ftos(100*relpc_lfeprt,"%*.*lf",6,1);

         tablerow3 = tablerow3 $+ "& {\\em "
                    $+ ftos(100*relpc_mleseprt,"%*.*lf",6,1) $+ " }& "
                    $+ "{\\em " $+ ftos(100*relpc_lfeseprt,"%*.*lf",6,1) $+ "}";
         
         if p_ind == 2;
            p_ind = p_ind + 2;
         else;           
            p_ind = p_ind + 1;
         endif;
         
      endo;
       
      tablerow1 = tablerow1 $+ " \\\\ ";      
      tablerow2 = tablerow2 $+ " \\\\ ";      
      tablerow3 = tablerow3 $+ " \\\\ ";      

      $tablerow1;
      $tablerow2;
      $tablerow3;
    
      T_ind = T_ind + 1;
            
   endo;
  
   /* add asymptotic risk */
         
   tablerow = " $\\infty$ & Risk";
          
   p_ind = 1;
   do until p_ind > p_n;
 
         relrisk_mleprt = ( risk_mle[h_ind, (alp_ind-1)*p_n+p_ind ]
                          - risk_lfe[h_ind,  alp_ind*p_n ] ) ./
                          risk_lfe[h_ind,  alp_ind*p_n ];


         relrisk_lfeprt = ( risk_lfe[h_ind, (alp_ind-1)*p_n+p_ind ]
                          - risk_lfe[h_ind,  alp_ind*p_n ] ) ./
                          risk_lfe[h_ind,  alp_ind*p_n ];

         tablerow = tablerow $+ " & " 
                    $+ ftos(100*relrisk_mleprt,"%*.*lf",6,1) $+ " &  "
                    $+ ftos(100*relrisk_lfeprt,"%*.*lf",6,1)  ;                  

         if p_ind == 2;
            p_ind = p_ind + 2;
         else;           
            p_ind = p_ind + 1;
         endif;
         
   endo;

   tablerow = tablerow $+ " \\\\ \\hline";      
   $tablerow;

   alp_ind = alp_ind + 1;
   
endo;

end;
