/* This program generates LaTeX tables for the paper
*/
new;
cls;
#include c:\projects\active\mismodel\gauss\mcspec.g


load path = ^mcoutpath Fdgp, Adgp, SIGeps, Wloss;
load path = ^mcoutpath risk_mlemc, risk_mlese, risk_lfemc, risk_lfese,
                       risk_optmc, risk_aicmc, risk_bicmc, risk_optse, risk_optbylagmc, risk_optbylagse,
                       pc_mlemc, pc_mlese, pc_lfemc, pc_lfese,
                       relpc_mlemc, relpc_mlese, relpc_lfemc, relpc_lfese,
                       risk_mle, risk_lfe,
                       Jointsel_count;

"Relative Risk and PC Estimates";
"";

/* fix forecast horizon */
h_ind = 3;

/* Iteration over Misspecification */

alp_ind = 1;
do until alp_ind > alp_n;

      tablerow1 = ftos(alp[alp_ind],"%*.*lf",2,0);
      tablerow1 = tablerow1 $+ " &  AIC " ;   
      tablerow2 = "   &  SIC ";
      tablerow3 = "   &  PC  ";
 
      /* Iteration over sample size */

      T_ind = 1;
      do until T_ind > T_n-1;

         risk_aicprt = (risk_aicmc[(h_ind-1)*T_n+T_ind, (alp_ind-1)*3+1:alp_ind*3]
                        - risk_lfemc[(h_ind-1)*T_n+T_ind, alp_ind*p_n ]) ./
                        risk_lfemc[(h_ind-1)*T_n+T_ind, alp_ind*p_n ];

         risk_bicprt = (risk_bicmc[(h_ind-1)*T_n+T_ind, (alp_ind-1)*3+1:alp_ind*3]
                        - risk_lfemc[(h_ind-1)*T_n+T_ind, alp_ind*p_n ]) ./
                        risk_lfemc[(h_ind-1)*T_n+T_ind, alp_ind*p_n ];


         risk_optprt = (risk_optmc[(h_ind-1)*T_n+T_ind, (alp_ind-1)*3+1:alp_ind*3]
                        - risk_lfemc[(h_ind-1)*T_n+T_ind, alp_ind*p_n ]) ./
                        risk_lfemc[(h_ind-1)*T_n+T_ind, alp_ind*p_n ];


         pred_ind = 1;
         do until pred_ind > 3;
       
            tablerow1 = tablerow1 $+ " & " 
                        $+ ftos(100*risk_aicprt[1,pred_ind],"%*.*lf",6,1) ;

            tablerow2 = tablerow2 $+ " & " 
                        $+ ftos(100*risk_bicprt[1,pred_ind],"%*.*lf",6,1) ;

            tablerow3 = tablerow3 $+ " & " 
                        $+ ftos(100*risk_optprt[1,pred_ind],"%*.*lf",6,1) ;

            pred_ind = pred_ind + 1;
 
         endo;                 

         T_ind = T_ind + 1;

      endo;
       
      tablerow1 = tablerow1 $+ " \\\\ ";      
      tablerow2 = tablerow2 $+ " \\\\ ";      
      tablerow3 = tablerow3 $+ " \\\\ \\hline ";      

      $tablerow1;
      $tablerow2;
      $tablerow3;
    

   alp_ind = alp_ind + 1;
   
endo;

end;
