/* This program generates LaTeX tables for the paper
*/
new;
cls;
#include c:\projects\active\mismodel\gauss\mcspec.g


load path = ^mcoutpath Fdgp, Adgp, SIGeps, Wloss;
load path = ^mcoutpath risk_mlemc, risk_mlese, risk_lfemc, risk_lfese,
                       risk_optmc, risk_optse, risk_optbylagmc, risk_optbylagse,
                       pc_mlemc, pc_mlese, pc_lfemc, pc_lfese,
                       relpc_mlemc, relpc_mlese, relpc_lfemc, relpc_lfese,
                       risk_mle, risk_lfe,
                       Jointsel_count, AICsel_count, BICsel_count;

"Model Selection Counts";
"";

/* fix forecast horizon */
h_ind = 3;

/* Iteration over Misspecification */

alp_ind = 1;
do until alp_ind > alp_n;


   tablerow11 = ftos(alp[alp_ind],"%*.*lf",2,0) $+ " & MLE(AIC) " ;
   tablerow12 = "  &  LFE(AIC) " ;         

   tablerow21 = "  &  MLE(SIC) ";
   tablerow22 = "  &  LFE(SIC) ";

   tablerow31 = "  &  MLE(PC)  ";
   tablerow32 = "  &  LFE(PC)  ";

   /* Iteration over sample size */

   T_ind = 1;
   do until T_ind > T_n-1;
   

      pcsel_countprt 
                  = Jointsel_count[(h_ind-1)*T_n+T_ind, (alp_ind-1)*2*p_n+1:alp_ind*2*p_n];

      pcsel_countprt 
                  = reshape( pcsel_countprt, 2, p_n);

      aicsel_countprt 
                  = aicsel_count[(h_ind-1)*T_n+T_ind, (alp_ind-1)*2*p_n+1:alp_ind*2*p_n];

      aicsel_countprt 
                  = reshape( aicsel_countprt, 2, p_n);

      bicsel_countprt 
                  = bicsel_count[(h_ind-1)*T_n+T_ind, (alp_ind-1)*2*p_n+1:alp_ind*2*p_n];
 
      bicsel_countprt 
                  = reshape( bicsel_countprt, 2, p_n);

         
      p_ind = 1;
      do until p_ind > p_n;
        
         tablerow11 = tablerow11 $+ " & " 
                    $+ ftos(100*aicsel_countprt[1,p_ind],"%*.*lf",6,0);
         tablerow12 = tablerow12 $+ " & " 
                    $+ ftos(100*aicsel_countprt[2,p_ind],"%*.*lf",6,0);

         tablerow21 = tablerow21 $+ " & " 
                    $+ ftos(100*bicsel_countprt[1,p_ind],"%*.*lf",6,0);
         tablerow22 = tablerow22 $+ " & " 
                    $+ ftos(100*bicsel_countprt[2,p_ind],"%*.*lf",6,0);

         tablerow31 = tablerow31 $+ " & " 
                    $+ ftos(100*pcsel_countprt[1,p_ind],"%*.*lf",6,0);
         tablerow32 = tablerow32 $+ " & " 
                    $+ ftos(100*pcsel_countprt[2,p_ind],"%*.*lf",6,0);
        
         p_ind = p_ind + 1;
         
      endo;
       
   
      T_ind = T_ind + 1;
            
   endo;

   tablerow11 = tablerow11 $+ " \\\\ ";    
   tablerow12 = tablerow12 $+ " \\\\ ";        

   tablerow21 = tablerow21 $+ " \\\\ ";      
   tablerow22 = tablerow22 $+ " \\\\ ";      

   tablerow31 = tablerow31 $+ " \\\\ ";      
   tablerow32 = tablerow32 $+ " \\\\ \\hline";      

   $tablerow11;
   $tablerow12;
   $tablerow21;
   $tablerow22;
   $tablerow31;
   $tablerow32;

  
   alp_ind = alp_ind + 1;
   
endo;

end;
