/* This program prints the results of MC experiment to Screen
*/
new;
cls;
#include c:\projects\active\mismodel\gauss\mcspec.g


load path = ^mcoutpath Fdgp, Adgp, SIGeps, Wloss;
load path = ^mcoutpath risk_mlemc, risk_mlese, risk_lfemc, risk_lfese,
                       risk_optmc, risk_optse,
                       risk_aicmc, risk_aicse, risk_bicmc, risk_bicse,
                       pc_mlemc, pc_mlese, pc_lfemc, pc_lfese,
                       relpc_mlemc, relpc_mlese, relpc_lfemc, relpc_lfese,
                       risk_mle, risk_lfe,
                       Jointsel_count, AICsel_count, BICsel_count;

/* Screen Output 
*/
format /mat /on /mb1 /rds 8,4;

h_ind = 1;
do until h_ind > h_n;

   alp_ind = 1;
   do until alp_ind > alp_n;

      risk_mleprt =   risk_mlemc[(h_ind-1)*T_n+1:h_ind*T_n, (alp_ind-1)*p_n+1:alp_ind*p_n ] |
                      zeros(1,p_n) |
                      risk_mle[h_ind,(alp_ind-1)*p_n+1:alp_ind*p_n] ;

      risk_lfeprt =   risk_lfemc[(h_ind-1)*T_n+1:h_ind*T_n, (alp_ind-1)*p_n+1:alp_ind*p_n ] |
                      zeros(1,p_n) |
                      risk_lfe[h_ind,(alp_ind-1)*p_n+1:alp_ind*p_n] ;

      risk_optprt = risk_optmc[(h_ind-1)*T_n+1:h_ind*T_n, (alp_ind-1)*3+1:alp_ind*3];

      jointsel_countprt 
                  = Jointsel_count[(h_ind-1)*T_n+1:h_ind*T_n, (alp_ind-1)*2*p_n+1:alp_ind*2*p_n]
                    ~ zeros(T_n,p_n);
      jointsel_countprt 
                  = reshape( Jointsel_countprt, T_n*3,p_n);

      aicsel_countprt 
                  = aicsel_count[(h_ind-1)*T_n+1:h_ind*T_n, (alp_ind-1)*2*p_n+1:alp_ind*2*p_n]
                    ~ zeros(T_n,p_n);
      aicsel_countprt 
                  = reshape( aicsel_countprt, T_n*3,p_n);

      bicsel_countprt 
                  = bicsel_count[(h_ind-1)*T_n+1:h_ind*T_n, (alp_ind-1)*2*p_n+1:alp_ind*2*p_n]
                    ~ zeros(T_n,p_n);
      bicsel_countprt 
                  = reshape( bicsel_countprt, T_n*3,p_n);

      risk_aicprt = risk_aicmc[(h_ind-1)*T_n+1:h_ind*T_n, (alp_ind-1)*3+1:alp_ind*3];

      risk_bicprt = risk_bicmc[(h_ind-1)*T_n+1:h_ind*T_n, (alp_ind-1)*3+1:alp_ind*3];


      relrisk_mleprt = ( risk_mlemc[(h_ind-1)*T_n+1:h_ind*T_n, (alp_ind-1)*p_n+1:alp_ind*p_n ]
                       - risk_lfemc[(h_ind-1)*T_n+1:h_ind*T_n, alp_ind*p_n ] ) |
                       zeros(1,p_n) |
                       ( risk_mle[h_ind,(alp_ind-1)*p_n+1:alp_ind*p_n] -
                           risk_lfe[h_ind,alp_ind*p_n] );

      relrisk_lfeprt = ( risk_lfemc[(h_ind-1)*T_n+1:h_ind*T_n, (alp_ind-1)*p_n+1:alp_ind*p_n ]
                       - risk_lfemc[(h_ind-1)*T_n+1:h_ind*T_n, alp_ind*p_n ] )|
                       zeros(1,p_n) |
                       ( risk_lfe[h_ind,(alp_ind-1)*p_n+1:alp_ind*p_n] -
                           risk_lfe[h_ind,alp_ind*p_n] );

      relpc_mleprt   = relpc_mlemc[(h_ind-1)*T_n+1:h_ind*T_n, (alp_ind-1)*p_n+1:alp_ind*p_n ];
      relpc_mleseprt   = relpc_mlese[(h_ind-1)*T_n+1:h_ind*T_n, (alp_ind-1)*p_n+1:alp_ind*p_n ];

      relpc_lfeprt   = relpc_lfemc[(h_ind-1)*T_n+1:h_ind*T_n, (alp_ind-1)*p_n+1:alp_ind*p_n ];
      relpc_lfeseprt   = relpc_lfese[(h_ind-1)*T_n+1:h_ind*T_n, (alp_ind-1)*p_n+1:alp_ind*p_n ];

      "Forecast Horizon:" h[h_ind];
      "Misspecification:" alp[alp_ind];
      "Columns: Lag length ";
      "Rows:    Sample Size";
      "";

      "-------------------------------------";
      "     R E L A T I V E   R I S K       ";
      "-------------------------------------";

      "Maximum Likelihood Plug-in Predictor";
      100*relrisk_mleprt;
      "";

      "Maximum Likelihood Predictive Criterion - Mean";
      100*relpc_mleprt;
      "";

      "Maximum Likelihood Predictive Criterion - SD";
      100*relpc_mleseprt;
      "";

      "Loss Function Plug-in Predictor";
      100*relrisk_lfeprt;
      "";

      "Loss Function Plug-in Predictive Criterion - Mean";
      100*relpc_lfeprt;
      "";

      "Loss Function Plug-in Predictive Criterion - SD";
      100*relpc_lfeseprt;
      "";

      "======================================";
      "";
      "";

      alp_ind = alp_ind + 1;
   endo;

   h_ind = h_ind + 1;
endo;

end;
